/* 
   
 */

logComment("Starting install")
initInstall("needlesearch", "/mozdev/needlesearch/icons", "1.0");
logComment("NeedleSearch Install initialized Version number: "+"1.0")

findDir = getFolder("Chrome","needlesearch/content/img");
setPackageFolder(findDir);

err = addDirectory("modern");

if ( err == SUCCESS ) { 
	logComment("Image Directory added succesfully")	
	setPackageFolder(findDir);
	err = addDirectory("modern/")
		
	if (err == SUCCESS) {
		logComment("Icon pack modern successfully added.")
	} else {
		logComment("Icon pack modern couldn't be added")
	}
	
	if (getPlatform() == "unix") {
		err = setUnixPermissions()
	}
	
  	//Perform the install
	err = performInstall();
	
	if ( err == SUCCESS ) {
		alert("The iconpack modern has been installed.\nPlease restart your browser to continue.");
		logComment("Iconpack modern successfully installed")
	} else { 
		alert("performInstall() bailed\n\nErrornumber: " + err);
		logComment("The iconpack modern couldn't be installed.\n\nErrornumber: " + err)
	}
} else { 
  alert("Creating the directory: needlesearch failed. Are you logged in as root?\nLinux/Unix user: make sure that all files in the directory chrome/needlesearch/ have write permissions\n\n" + err);
  logComment("NeedleSearch directory couldn't created in the Chrome directory.")
}



/**
*	Useful functions
*
*/

function setUnixPermissions() {
	logComment("In setUnixPermissions()")
	
	//Get os root
	var osRoot = getFolder("OS Drive")
	if (!File.isDirectory(osRoot)) {
		logComment("Couldn't find OS Drive for UNIX install")
		return DOES_NOT_EXIST
	}
	
	//Get bin folder
	var bin = getFolder(osRoot, "bin")
	if (!File.isDirectory(bin)) {
		logComment("Couldn't find bin folder for UNIX install")
		return DOES_NOT_EXIST
	}

	//Get chmod
	var chmod = getFolder(bin, "chmod")
	if (File.exists() == false) {
		logComment("Couldn't find Chmod for UNIX install")
		return DOES_NOT_EXIST
	}
	
	logComment("Chmod located at: " + chmod)
	
	//Here we go!
	err = File.execute(chmod, " 775 -R " + getFolder("Chrome", "needlesearch"))
	if (err == SUCCESS) {
		logComment("File permissions all set!")
	} else {
		logComment("File permissions problem. Error: " + err)
	}
	
	
}

function getPlatform() {

  var platformStr, platformNode;
  if('platform' in Install) {
	platformStr = new String(Install.platform);

    // Mac OS X (aka Darwin) is a real unix system

    if (!platformStr.search(/.*Darwin/))
      platformNode = 'unix';
    else if (!platformStr.search(/^Macintosh/))
      platformNode = 'mac';
    else if (!platformStr.search(/^Win/))
      platformNode = 'win';
    else if (!platformStr.search(/^OS\/2/))
      platformNode = 'win';
    else
      platformNode = 'unix';
  } else {

    var fOSMac  = getFolder("Mac System");
    var fOSWin  = getFolder("Win System");
    logComment("fOSMac: "  + fOSMac);
    logComment("fOSWin: "  + fOSWin);
    if(fOSMac != null)
		platformNode = 'mac';
    else if(fOSWin != null)
      platformNode = 'win';
    else
      platformNode = 'unix';
  }

	logComment("Install for platform " + platformNode)

  return platformNode;

}

